import GamefieldPointer from "./GamefieldPointer"
import Ship from "./Ship"
import { useGameProps } from "@hooks/useGameProps"
import { composeTargetTiles, shipProps } from "@lib/utils/helpers"

function Targets() {
  const { payload, target, targetPreview, mode, hits, ships } = useGameProps()

  if (payload?.game?.state === "running")
    return (
      <>
        {[
          ...composeTargetTiles(target, mode, hits).map((props, i) => (
            <GamefieldPointer key={"t" + i} props={props} />
          )),
          ...composeTargetTiles(targetPreview, mode, hits).map((props, i) => (
            <GamefieldPointer key={"p" + i} props={props} preview />
          )),
        ]}
      </>
    )

  if (payload?.game?.state === "starting" && mode >= 0 && targetPreview.show)
    return <Ship preview props={shipProps(ships, mode, targetPreview)} />
}

export default Targets
